-- Aufgabe Vorlesung PdfP, Frank Herklotz

module Partition where


------------------------------------------------------------

-- Beispiele: werte diese Ausdrcke aus:

--   partition 5
--   u_partition 5
--   f_partition 5

------------------------------------------------------------

data Partition = Partition [Integer] deriving Show


-- alle Partitionen

partition :: Integer -> [ Partition ]
partition n = part n n

part 0 m = [ Partition []]
part n m  |  m <= 0 = []
part n m = [ Partition $ m : xs
           | n - m >= 0
           , Partition xs <- part (n - m) m
           ]
     ++    part n (m - 1)


-- "ungerade" Partitionen

u_partition :: Integer -> [ Partition ]
u_partition n = u_part n n

u_part 0 m = [ Partition []]
u_part n m  |  m <= 0 = []
u_part n m = [ Partition $ m : xs
           | n - m >= 0 && odd m			-- nur wenn ungerade
           , Partition xs <- u_part (n - m) m
           ]
     ++    u_part n (m - 1)


-- "streng monoton fallende" Partitionen

f_partition :: Integer -> [ Partition ]
f_partition n = f_part n n

f_part 0 m = [ Partition []]
f_part n m  |  m <= 0 = []
f_part n m = [ Partition $ m : xs
           | n - m >= 0 && n - m < m			-- nur wenn streng monoton fallend
           , Partition xs <- f_part (n - m) m
           ]
     ++    f_part n (m - 1)


-- Vermutung:
-- es gilt |u_partition n| = |f_partition n|

-- HIDE