module Main where

import SOEGraphics

zwischen :: Point -> Point -> Point
zwischen (x1, y1) (x2, y2) = ((x1 + x2) `div` 2, (y1 + y2) `div` 2)

fill :: Int -> Point -> Point -> Point -> Point -> Graphic
fill n ul ur or ol =
    let mr = zwischen ur or; ml = zwischen ul ol
	mu = zwischen ul ur; mo = zwischen ol or
	mm = zwischen ul or
    in	if n == 0
	   then polyline [ ul, ur, mr, mm, mo, ol, ml, ul ]
	   else let mol = zwischen mm ol; mul = zwischen mm ul
		    mur = zwischen mm ur; mor = zwischen mm or
		in  overGraphics [ fill (n-1) ol ml mm mo
				 , fill (n-1) ul mu mm ml
				 , fill (n-1) ur mr mm mu
				 , fill (n-1) mul mur mor mol
				 ]

size = 800 :: Int

parkett n = fill n (0,0) (size, 0) (size, size) (0, size)

main = runGraphics $ do
    w <- openWindow "Ammann" (size, size)
    drawInWindow w $ parkett 5
    k <- getKey w
    closeWindow w

    