module Ammann


( probiere
, module Koordinaten
)

where


import Winkel
import Kleben
import Correct

import Koordinaten

---------------------------------------------------------------------------


data Ammann = Nichts | Rand | Mitte | Spitze
     deriving (Eq, Ord, Show)

stein :: Streckenzug Ammann 
stein = Streckenzug 
     [ Ecke { sichtbar = w % 4, alle = [ w % 4] 
	    , info = [f] }
     | (f, w) <- zip 
	   [ Spitze, Nichts, Rand, Nichts, Mitte, Nichts, Rand, Nichts ]
	   [ 1,	     2,	     1,	   1,	   3,	  1,	  1,    2	]
     ]

-------------------------------------------------------------------------

steine = take 8 $ iterate (drehe 1) $ stein

drehe :: Int -> Streckenzug i -> Streckenzug i
drehe k (Streckenzug xs) = 
    let (pre, post) = splitAt k xs	
    in	Streckenzug (post ++ pre)

---------------------------------------------------------------------------

instance Correct Ammann where
    correct xs =
        if Nichts `elem` xs 
	then and [ Nichts == x | x <- xs ]
	else if Spitze `elem` xs
	then and [ Rand /= x   | x <- xs ]
	else True


---------------------------------------------------------------------------

prob ps q = q : do
     p  <- ps
     q' <- klebe q p
     prob ps ( drehe  (lnge q `div` 2 ) q')

-- wird vom Hauptprogramm benutzt
probiere :: [ Streckenzug Ammann ]
probiere = do
    let  ps =  steine
    prob ps (head ps)

