module Anamorph

where

import List (partition)
import Tree

anamorph :: (b -> Maybe (b, a, b)) -> (b -> Tree a)
anamorph f x =
    case f x of
        Nothing	       -> Leaf
	Just (l, k, r) -> Node { left  = anamorph f l
			       , key   = k
			       , right = anamorph f r
			       }

complete :: Int -> Tree Int
complete = anamorph 
	 $ \ x -> if x == 0 
		  then Nothing 
		  else Just (x - 1, x, x - 1) 

fibo :: Int -> Tree Int
fibo = anamorph 
     $ \ x -> if x <= 1 
	      then Nothing
	      else Just (x - 1, x, x - 2) 

build :: Ord a => [a] -> Tree a
build = anamorph
      $ \ xs -> if null xs
		then Nothing
		else let (klein, gro) = partition ( < head xs ) (tail xs)
		     in	 Just (klein, head xs, gro)
