module Ecken

where

winkel :: Integer -> Rational    
winkel n =  1 % 2 - 1 % n

ecken :: [[Integer]]
-- welche Eckentypen knnen bei regulren Parkettierungen vorkommen?
-- dabei ist ein Eckentyp eine nichtfallende Folge der Seitenzahlen
-- der Menge der Polygone, die dort zusammenstoen

ecken = [ m : ms
	| m <- [ 3 .. 6 ] -- das kleinste ist 3 .. 6 eck
	, ms <- eck m (1 - winkel m)
	]

eck :: Integer -> Rational -> [[Integer]]
-- es ist noch ein winkel alpha zu fllen,
-- mit regulren polygonen von je >= m seiten
eck m alpha = 
    -- wir bentigen noch wenigstens zwei Polygone?
    [ m' : ms
    | (m', alpha') <- 
	    takeWhile ( \ (m', alpha') -> alpha' >= winkel m' )
		      [ (m', alpha - winkel m') 
		      | m' <- [m .. ] -- Vorsicht: eine unendliche Liste!
		      ]
    , ms <- eck m' alpha'
    ]
    ++
    -- Winkel ist ein Eckenwinkel eines regulren Polygons?
    [ [ numerator x ]
    | alpha < 1 % 2
    , let x = 1 / (1 % 2 - alpha)
    , 1 == denominator x 
    , numerator x >= m
    ]

---------------------------------------------------------------------------
