module Einfache_Queue where

data Item a = Event a
	    | Pause Int
     deriving Show

type Queue a = [ Item a ]


p :: Queue String
p =  [ i | k <- [1 .. 11], i <- [ Event ("P" ++ show k), Pause k ] ]

q :: Queue String
q =  [ i | k <- [1 .. 11], i <- [ Event ("Q" ++ show k), Pause 6 ] ]


nacheinander :: Queue a -> Queue a -> Queue a
nacheinander xs ys = xs ++ ys


nebeneinander :: Queue a -> Queue a -> Queue a

nebeneinander [] ys = ys
nebeneinander xs [] = xs

nebeneinander (Event e : xs) ys = Event e : (nebeneinander xs ys)
nebeneinander xs (Event f : ys) = Event f : (nebeneinander xs ys)

nebeneinander (Pause a : xs) (Pause b : ys) =
         if a < b then Pause a : nebeneinander xs (Pause (b - a) : ys)
    else if a > b then Pause b : nebeneinander (Pause (a - b) : xs) ys 
    else               Pause a : nebeneinander xs ys

