module Euklid 

( ecke, regular
, probiere
, module Koordinaten
)

where

import Winkel
import Ecken (winkel)
import Regular
import Kleben
import Koordinaten

---------------------------------------------------------------------------

ecke :: [[Integer]] -> Integer -> Ecke Regular
-- Innenecke eines regulren n-ecks
ecke ts n =  Ecke { sichtbar = winkel n
		  , alle = [ winkel n ]
		  , info = [ Regular { typen = ts, grad = n } ]
		  }

regular :: [[Integer]] -> Integer -> Streckenzug Regular
-- ein regulres n-Eck
regular ts n = Streckenzug $ take (fromInteger n) $ repeat $ ecke ts n

instance Correct Regular where
    -- die Liste der Grade mu aus der erlaubten Teilmenge kommen
    correct xs = let t = typen (head xs)
		     gs = map grad xs
		 in  gs `elem` t

---------------------------------------------------------------------------

prob ps q = q : do
     p <- ps
     q' <- klebe q p
     prob ps q'

-- wird vom Hauptprogramm benutzt
probiere :: [ Streckenzug Regular ]
probiere = do
    let gs = [ 6,3,3,3,3]
	ts = teilmengen gs
	ps = [ regular ts g | g <- gs ]
    prob ps (head ps)

