module Fehler 

( Fehler, falsch, export
)

where

import MonadZero
import MonadPlus
import Position

data Fehler a = Falsch  Position
	      | Richtig a
     deriving Show

falsch :: Position -> Fehler a
falsch p = Falsch p

instance Functor Fehler where
    fmap f (Falsch  p) = Falsch p
    fmap f (Richtig x) = Richtig (f x)

instance Monad Fehler where
    return x = Richtig x
    Richtig x >>= f  =  f x
    Falsch  p >>= f  =  Falsch p

instance MonadPlus Fehler where
    Richtig x `plus` _         = Richtig x     
    Falsch  p `plus` Richtig y = Richtig y
    Falsch  p `plus` Falsch  q = Falsch (max p q)

export :: Fehler a -> Either String a
export (Falsch  p) = Left (show p)
export (Richtig x) = Right x
