module Let_Eval where

import Let_Type
import Let_Form
import Env

meaning :: Op -> (Integer -> Integer -> Integer)
meaning Plus  = (+)
meaning Minus = (-)
meaning Mal   = (*)
meaning Durch = div

eval :: Envs Integer -> Term -> Integer
eval envs t = case t of
    Constant n  -> n
    Apply o l r -> let [ x, y ] = map (eval envs) $ [ l, r ] 
		       f = meaning o
		   in  f x y
    Var n -> case finds envs n of
		  Nothing -> error $ "Variable " ++ n ++ " nicht gebunden"
		  Just x  -> x
    Let binds body -> let
	    env = mkEnv [ (n, eval envs t) | (n, t) <- binds ]
	in  eval (env : envs) body

eval_top :: Term -> Integer
eval_top = eval nullEnvs


