module Monad_Let_Eval where

import Let_Type
import Let_Form
import Env
import Meaning

import MonadZero
import MonadPlus

import Prelude hiding (mapM)
import MapM

eval :: (MonadZero m, MonadPlus m) 
     => Envs Integer -> Term -> m Integer
eval envs t = case t of
    Constant n  -> return n
    Apply o l r -> do let [mx, my] = map (eval envs) [l, r]
		      let f = meaning o
		      x <- mx; y <- my
		      f x y
    Var n -> case finds envs n of
		  Nothing -> error $ "Variable " ++ n ++ " nicht gebunden"
		  Just x  -> return x
    Let binds body -> do
	    nxs <- mapM ( \ (n, t) -> do x <- eval envs t
				         return (n, x) )
			binds	    
	    eval (mkEnv nxs : envs) body

eval_top :: (MonadZero m, MonadPlus m) 
	 => Term -> m Integer
eval_top = eval nullEnvs


