module Partition where

import Bild
import Form

------------------------------------------------------------

-- Beispiele: werte diese Ausdrcke aus:

--   partition 5
--   zeige $ partition 5

------------------------------------------------------------


data Partition = Partition [ Integer ] deriving Show

instance Form Partition where
    form (Partition xs) =
        abstand $ kasten $
        nebens [ bers [ kreis 1 | k <- [1 .. x] ] 
	       | x <- xs 
	       ]

------------------------------------------------------------

partition :: Integer -> [ Partition ]
partition n = part n n

part 0 m = [ Partition []]
part n m  |  m <= 0 = []
part n m = [ Partition $ m : xs
	   | n - m >= 0
	   , Partition xs <- part (n - m) m
	   ]
     ++	   part n (m - 1)

-- HIDE

u_partition :: Integer -> [ Partition ]
u_partition n = u_part n (if odd n then n else n - 1)

u_part 0 m = [ Partition [] ]
u_part n m  |  m <= 0 = []
u_part n m = [ Partition $ m : xs
	   | n - m >= 0
	   , Partition xs <- u_part (n - m) m
	   ]
     ++	   u_part n (m - 2)

------------------------------------------------------------

f_partition :: Integer -> [ Partition ]
f_partition n = f_part n n

f_part 0 m = [ Partition []]
f_part n m  |  m <= 0 = []
f_part n m = [ Partition $ m : xs
	   | n - m >= 0
	   , Partition xs <- f_part (n - m) (m - 1)
	   ]
     ++	   f_part n (m - 1)

------------------------------------------------------------

