module Position_Parser_Basic

( Parser, parse
, item, eof, pos
, guard, plus
)

where


import General_Parser_Type

import Fehler
import Position

import MonadZero 
import MonadPlus (plus)

type Parser = GP Fehler (Char, Position)

instance MonadZero Parser where
  -- das geht nur mit dem switch  hugs -98
  -- weil Parser ein Typ-Synonym ist
  zero = GP $ \ input -> case input of
     ((c, p) : cps) -> falsch p
     []		    -> falsch EOF


item :: Parser Char
item = GP $ \ input -> case input of
     ((c, p) : cps) -> return (c, cps) 
     []		   -> falsch EOF

eof :: Parser ()
eof = GP $ \ input -> case input of
    []		   -> return ((), []) 
    ((c, p) : cps)  -> falsch p

pos :: Parser Position
pos = GP $ \ input -> case input of
    ((c, p) : cps) -> return (p, cps)
    []		   -> return (EOF, [])


parse :: Parser a -> String -> Either String a
parse p input = export $ do
    (x, rest) <- run p $ annotate input
    return x


    
