module Rose 



where

import Ding
import Form
import Bild

data Rose a = Node { key :: a
		   , children :: [ Rose a ]
		   }
     deriving Show


instance Form a => Form (Rose a) where
    form t = krone (form (key t)) (map form (children t))


binomial :: Int ->  Rose Int
binomial n = Node { key = n
		  , children = [ binomial k | k <- [0 .. n - 1] ]
		  }


instance Functor Rose where
   fmap f t = Node { key = f (key t)
		   , children = map (fmap f) (children t)
		   }


preorder :: Rose a -> [a]
preorder t = key t : [ x | c <- children t, x <- preorder c ]


-- Baum nur bis zur Tiefe d
cut :: Int -> Rose a -> Rose a
cut n t = Node { key = key t
	       , children = if n == 0 then []
			    else map (cut (n-1)) (children t)
	       }


