module Term where

import Form
import Bild
import Sort

data Term = Leaf
	  | Variable { name :: Int }
	  | Node { left :: Term, right :: Term }
     deriving Show

instance Eq Term where
    Leaf == Leaf = True
    Variable { name = v } == Variable { name = w } = v == w
    Node { left = l, right = r } == Node { left = ll, right = rr } =
	 (l == ll) && (r == rr)
    _ == _ = False

tfold :: b -> (Int -> b) -> (b -> b -> b) -> (Term -> b)
tfold leaf var node (Leaf) = leaf
tfold leaf var node (Variable { name = n }) = var n
tfold leaf var node (Node { left = l, right = r }) =
      node (tfold leaf var node l) (tfold leaf var node r)



instance Form Term where
    form = tfold ( kreis 0.5 )
		 ( form )
		 ( \ l r -> krone (kreis 0.5) [ l, r ] )

variables :: Term -> [ Int ]
variables = unique . tfold [] ( \ n -> [n] ) (++)

