module Transform where

import Matrix

type Punkt = (Double, Double)
type Transform = Matrix Double

anwend :: Transform -> Punkt -> Punkt
anwend t p @ (x, y) = 
    let v = vektor [ x, y, 1 ]
	w = t * v
	[ r, s, _ ] = unvektor w
    in	(r, s) 

hv :: Transform
hv = matrix (3,3) [ [ 1,  0, 0 ]
		  , [ 0, -1, 0 ]
		  , [ 0,  0, 1 ]
		  ]

drehe :: Double -> Transform
drehe alpha = 
    let s = sin alpha; c = cos alpha
    in	matrix (3,3) [ [  c, s, 0 ]
		     , [ -s, c, 0 ]
		     , [  0, 0, 1 ]
		     ]

schiebe :: Punkt -> Transform
schiebe (x, y) = 
    matrix (3,3) [ [ 1, 0, x ]
		 , [ 0, 1, y ]
		 , [ 0, 0, 1 ]
		 ]

skaliere :: Double -> Transform
skaliere f = matrix (3,3) [ [ f, 0, 0 ]
			  , [ 0, f, 0 ]
			  , [ 0, 0, 1 ]
			  ]



