module Unify where

import Term
import Subst

unify :: Term -> Term -> Maybe Subst
unify t1 t2 = uni [] t1 t2

uni :: Subst -> Term -> Term -> Maybe Subst

-- identische Terme gehen immer
uni current l r | l == r = Just current

-- eine Variable wird gebunden (beachte n /= r)
uni current (Variable { name = n }) r =
    if n `elem` variables r -- der berhmte occurs-check
    then Nothing 
    else return $ (n, r) : current 
uni current l r @ (Variable { name = n }) = 
    uni current r l

-- hier ist r keine Variable
uni current Leaf r =
    if r == Leaf then return current else Nothing
uni current l r @ Leaf =
    uni current r l

-- jetzt sind beides Verwzeigungen
uni current t1 t2 = do
    lsub <- uni current (left t1) (left t2) 
    rsub <- uni lsub (apply lsub (right t1))
		     (apply lsub (right t2))
    return rsub
